﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence;
using Telerik.Windows.Persistence.Services;

namespace GridViewTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private Stream stream;
		public MainWindow()
		{
			InitializeComponent();

			ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new RadGridViewCustomPropertyProvider());
			this.DataContext = new MainViewModel();

		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			PersistenceManager manager = new PersistenceManager();
			this.stream = manager.Save(this.gridView);
		}

		private void RadButton_Click_1(object sender, RoutedEventArgs e)
		{
			this.stream.Position = 0L;
			PersistenceManager manager = new PersistenceManager();
			manager.Load(this.gridView, this.stream);

			this.LoadContextMenu();
		}
  
		private void LoadContextMenu()
		{
			//Load Context Menu
			RadContextMenu ctxMenu = new RadContextMenu();
			foreach (Telerik.Windows.Controls.GridViewColumn column in this.gridView.Columns)
			{
				RadMenuItem sitem = new RadMenuItem() { Header = column.Header, IsCheckable = true, IsChecked = true };
				sitem.SetBinding(RadMenuItem.IsCheckedProperty, new Binding("IsVisible") { Mode = BindingMode.TwoWay, Source = column });
				ctxMenu.Items.Add(sitem);
			}

			RadContextMenu.SetContextMenu(this.gridView, ctxMenu);
		}

		private void OnGridViewLoaded(object sender, RoutedEventArgs e)
		{
			this.LoadContextMenu();
		}
	}
}
